#include <stdlib.h>
#include <new>
#include <limits>
#include <string.h>
#include <iomanip>
#include <iostream>
#include <vector>

size_t AllocatedSize = 0;

template <class TDType> class TDSTLAllocator
{
public:
	typedef size_t size_type;
	typedef ptrdiff_t difference_type;
	typedef TDType * pointer;
	typedef const TDType * const_pointer;
	typedef TDType & reference;
	typedef const TDType & const_reference;
	typedef TDType value_type;

	template <class TDOther> struct rebind { typedef TDSTLAllocator<TDOther> other; };

public:

	pointer address(reference v) const
	{
		return (&v);
	}

	const_pointer address(const_reference v) const
	{
		return (&v);
	}

	TDSTLAllocator() throw() {}

	TDSTLAllocator(const TDSTLAllocator<TDType> & src) throw() {}

	template<class TDOther> 
		TDSTLAllocator(const TDSTLAllocator<TDOther> & src) throw() {}

	TDSTLAllocator& operator=( const TDSTLAllocator& ha )
	{
		return *this;
	}

	pointer allocate(size_type _Count, const_pointer _Hint = 0)
	{
		unsigned char * tp;
		tp = new unsigned char[_Count * sizeof(TDType)];

		//monitoring
		AllocatedSize += _Count * sizeof(TDType);
		std::cout << "on allocate : AllocatedSize " << AllocatedSize << std::endl;

		//
		return (pointer)tp;
	}

	void construct(pointer _Ptr, const TDType & _Value)
	{
		new((void*)_Ptr) TDType(_Value);
	}

	void deallocate(pointer _Ptr, size_type _Count)
	{
		//monitoring
		AllocatedSize -= _Count * sizeof(TDType);
		std::cout << "on deallocate : AllocatedSize " << AllocatedSize << std::endl;

		//
		delete [] (unsigned char *)_Ptr;
	}

	void destroy(pointer _Ptr)
	{
		_Ptr->~TDType();
	}

	size_type max_size() const throw()
	{
		return std::numeric_limits<size_t>::max() / sizeof(TDType);
	}


};

template <typename T1> bool operator==( const TDSTLAllocator<T1>& lhs, const TDSTLAllocator<T1>& rhs) throw()
{
	return (bool)true;
}

template <typename T1> bool operator!=( const TDSTLAllocator<T1>& lhs, const TDSTLAllocator<T1>& rhs) throw()
{
	return (bool)false;
}


void AllocatorVectorTest()
{
	TDSTLAllocator<char> a;
	std::vector<char, TDSTLAllocator<char> > v(a);

	v.resize(5);

}

int main()
{
	AllocatorVectorTest();

	return 0;
}
